/*
	Designed & modify by Xempo(Linjinaghua)
	Copyright 2004-2005 Xempo
	reserve all rights of this file
*/

#ifndef _CC2004_CODE_
#define _CC2004_CODE_

#include "\c_lib\c_lib.def"

void FreeMctrl(_memctrl *lnk)
{
_memctrl *nxmb;
while(lnk){
	nxmb=lnk->nx;	free(lnk->buff);	
	free(lnk);	lnk=nxmb;
	}
}

_memctrl *AppMctrl(int len)
{
_memctrl *lnk=(_memctrl *)malloc(sizeof(_memctrl));
memset(lnk,0,sizeof(_memctrl));
lnk->tlen=len;
lnk->buff=(char *)malloc(len);
*lnk->buff=0;
return lnk;
}

_memctrl *SetMctrl(_memctrl *lnk,char *txt,int len,int tlen)
{
if(len==0)len=strlen(txt)+1;
if(lnk->tlen - lnk->uselen>len+2){
bckdat:	memcpy(lnk->buff+lnk->uselen,txt,len);
	lnk->uselen+=len;
	lnk->nDat++;
	}
else {
_memctrl *pk=AppMctrl(tlen);
lnk->nx=pk;	lnk=pk;
goto bckdat;
	}
return lnk;
}

_memctrl *delMctrl(_memctrl *mb1,_memctrl *delmb)
{
_memctrl *mb0=mb1, *pmb=mb0;
while(mb1&&mb1!=delmb){
	pmb=mb1;	mb1=mb1->nx;
	}

if(mb1!=mb0){	pmb->nx=mb1->nx;
	free(mb1->buff);free(mb1);
	return mb0;
	}
else if(mb0->nx){	mb1=mb0->nx;
	free(mb0->buff);free(mb0);
	return mb1;
	}
/* this time, cell->tn=0 */
mb0->uselen=0;
return mb0;
}

bool IsDone(int val,int *msg)
{
int i;
for(i=0;msg[i] && msg[i]!=val;i++);
return !msg[i];
}

int GetScnLen(char *plin,int iScn,int flg)
{
int n,shw=0;
 int i;
if(plin==NULL)return 0;
for(i=0;shw<iScn&&plin[i]!=10&&plin[i];i++)
	if(plin[i]==9){n=shw, shw+=tblen-shw%tblen; }
	else shw++;
return( flg<0 && shw>iScn ? n:shw );
}

void GetTxtRect(char *txt,int *cnline,int *mxlen)
{
unsigned int i,j;
*mxlen=GetScnLen(txt,2000,1);
for(*cnline=1,i=0;txt[i];i++)
	if(txt[i]=='\n'){
		(*cnline)++;
		j=GetScnLen(txt+i+1,2000,1);
		if(*mxlen<j)*mxlen=j;
	}
}

/*char ***MemsApp(int row,int col)
{ because in 3[], unsure fix the 2 var,
it like x+y=7, x & y is unsure 
char  **pdat, ***pt;
int i;
pt=(char  ***)malloc( row*4 );
pdat=(char  **)malloc( row * col * 4 );
for(i=0; i<row; i++)pt[i]=pdat+i*col;
return pt;
}

void MemsFree(char  ***pt)
{
if(pt){	free(pt[0]);	free(pt);	}
}*/

int (*popMsg)(char *txt,char *cap,int msg);
void (*BrowKuang)(char *txt,char *cap);

unsigned int delete(char *pt,unsigned int cn)/* return really cut cn */
{
unsigned int len=strlen(pt);
if(cn>=len){ *pt=0; return len; }
memmove(pt,pt+cn,len+1);
return cn;
}

void Insert(char *sc,char *in)
{
size_t len=strlen(in);
memmove(sc+len,sc, strlen(sc)+1 );
memcpy(sc,in,len);
}

unsigned int FmtInput(char *Inp)
{
unsigned int i,n,len;
int fg=0;
char  *pt;
if(Inp==NULL)return 0;
pt=strdup(Inp);
len=strlen(Inp);
for(n=0,i=0;i<len;i++)
   if(pt[i]==32){
	if(fg){ fg=0; Inp[n++]=pt[i]; }
	}
   else { fg=1; Inp[n++]=pt[i]; }
Inp[n]=0;
free(pt);
return n;
}

unsigned int Time_cc(char *txt)
{
unsigned int tm;
int j, n, i, len;
char *pt,	*dat=strdup(txt);
len=FmtInput(dat)+1;
fmtstr(dat,"-:|",' ');	pt=dat;	
for(j=0,i=0;i<len;i++)if((dat[i]|32)==32){
dat[i]=0;/*	fmtVal(pt);*/n=atoi(pt);
switch(j){
case 0 : tm=n<<11;	break;
case 1 : tm|=n<<5;	break;
case 2 : tm|=n>>1;
	}
j++;	pt=dat+i+1;
	}
return tm;
}

unsigned long Date_cc(char *txt)
{
unsigned long ftm;
unsigned int mmdd=0, year=0;

int j, n, i, len;
char *pt,	*dat=strdup(txt);
len=FmtInput(dat)+1;
fmtstr(dat,"-:|",' ');	pt=dat;	
for(j=0,i=0;i<len;i++)if((dat[i]|32)==32){
dat[i]=0;/*	fmtVal(pt);*/n=atoi(pt);
switch(j){
case 0 : year=n;	break;
case 1 : mmdd|=n<<5;	break;
case 2 : mmdd|=n;	break;
}
j++;	pt=dat+i+1;
	}
ftm=year;		free(dat);
return ((ftm<<16)|mmdd);
}

char *cc_Date(unsigned long dt)
{
static char buf[20];
int year=dt>>16, mmdd=dt&0xffff;
sprintf(buf,"%d-%02d-%02d",year,(mmdd>>5)&15,mmdd&31);
return buf;
}

char *cc_Time(unsigned int tm)
{
static char buff[20];
sprintf(buff,"%02d:%02d:%02d",(tm>>11)&31,(tm>>5)&63,(tm<<1)&31);
return buff;
}

char *ReSetBuf(FILE *fp,long sz,int lmt)
{
if(sz>BUFSIZ*2){
char  *buff;
int bufsz;
bufsz=sz>lmt? lmt:sz;
buff=(char  *)malloc(bufsz);
setvbuf(fp,buff,_IOFBF,bufsz);
return buff;
	}
return NULL;
}

int fmtVal(char *val)/* this is last define */
{
int i, j, b, Ln=strlen(val);
b=Ln;
for(i=0; i<Ln && (val[i]==9||val[i]==32); i++);
if(i>=Ln){ *val=0; return 0; }
if(val[i]=='\"')i++;
for(j=Ln-1; j>=0 && (val[j]==9||val[j]==32); j--);
if(val[j]=='\"')j--;
if(j+1<=i){ *val=0; return 0; }

if( i>0||j<Ln-1 ){
	for(b=0;i<=j;i++,b++)val[b]=val[i];
	val[b]=0;
	}
return b;
}

void fmtstr(char *pChs,char *df,char c)
{/* use c replace all df in pChs */
int i;/*ln=strlen(pChs);*/
for(i=0;pChs[i];i++)if(strchr(df,pChs[i])){
		if(i==0||pChs[i-1]==c){
			/*for(j=i,a=strlen(pChs);j<a;j++)pChs[j]=pChs[j+1];pChs[a-1]=0;*/
			delete(pChs+i,1);  i--;
			}
		else pChs[i]=c;
	}
}

/*  flg:
0 bit: setbit is first string; else  is last string
1 bit: setbit is use case; else is no case
return flg!=0  sc==in
*/
char *memstr(char *sc,unsigned int ln,char *in,unsigned int ln2,int *flg)/*ִСд*/
{
unsigned int  i,a;
int fg=*flg&1, CS=*flg&2, TongFg=*flg&128;
char chr,  *pt=NULL,
	bg=1; /* d chs */
 int j;
if(sc==NULL||in==NULL)goto ex;
if(ln==0)ln=strlen(sc);
if(ln2==0)ln2=strlen(in);
if(ln2>ln){
ex: *flg=FALSE; return NULL;
}

for(i=0;i<ln;i++){
 if(bg){ /* d chs */
   for(a=i,j=0;a<ln&&j<ln2;j++,a++){
	if((TongFg&&in[j]=='?')||sc[a]==in[j] )continue;
	if(CS==0){/*ִСд*/
	  chr=sc[a]|32;
	  if(chr>96 && chr <123 && chr==(in[j]|32) )continue;
		}
		break;
	  }/* end for */

	if(j>=ln2){
		pt=sc+i;
		if(fg)goto ex1;
		}
	else if(ln-i<=ln2)break;
  }/*  d chs  */
  if(sc[i]<0)bg=1-bg;
  else bg=1;
}
ex1: *flg = (i==0&&j==ln)? 1:0; /* flg!=0 is sc==in */
return pt;
}

int KShowMsg(char *fnm,char *fmt,int msg)
{
int rt;
char *bu=(char *)malloc(strlen(fnm)+strlen(fmt)+4 );
sprintf(bu,fmt,fnm);
rt=popMsg(bu,NULL,msg);
free(bu);
return rt;
}

char *strdup(char *sc)
{
char *pt=(char *)malloc(strlen(sc)+4);
strcpy(pt,sc);
return pt;
}

char *catstr(char *fnm,char *extnm)
{
char *fnm2=(char *)malloc(strlen(fnm)+strlen(extnm)+4);
sprintf(fnm2,"%s%s",fnm,extnm);
return fnm2;
}

char *GetLibDat(Xbi *pblk,char *tabname,long nmb,MAU *pdat,MAU *pdat2)
{
char *dat;
XbiTAB *tab=TabOpen(pblk,tabname);
if(tab==NULL)return NULL;
dat=GetNmbval(pblk,tab,nmb,pdat,pdat2);
if(tab!=pblk->ctab)free(tab);
return(dat);
}

char *SetLibDat(Xbi *pblk,char *tabname,long numb,MAU *pdat,MAU *pdat2)
{
char *dat;
XbiTAB *tab=TabOpen(pblk,tabname);
if(tab==NULL)return NULL;
dat=SetNmbval(pblk,tab,numb,pdat,pdat2);
if(tab!=pblk->ctab)TabClose(pblk,tab);
return(dat);
}

FILE *PathOpen(char  *fnm,char *fmode)
{
FILE *fp;
char  *pt=fnm;
start:fp=fopen(pt,fmode);
if(fp==NULL){
	if(pt==fnm&&_ProgPath){
		pt=catstr(_ProgPath,fnm);
		goto start;
		}
	else if(pt!=fnm)free(pt);
	}
return fp;
}

char nOpen[]="Can't open the file: %s !";
char **GetDscpt(char *fnm,int n)
{/* return (dscpt)pts, n is pts cn */
FILE *fp;
size_t  cn;
int i,j;
char *pt,
**DScpt=(char **)malloc(n*4);
if( (fp=PathOpen(fnm,"rt"))==NULL ){
	for(i=0;i<n;i++)DScpt[i]="No chs's file!";
	KShowMsg(fnm,nOpen,MB_ICONERROR);
	}
else {
	fseek(fp,0,2);	cn=ftell(fp);	rewind(fp);
	pt=(char *)malloc(cn+4);
	DScpt[0]=pt;
	cn=fread(pt,1,cn,fp);	pt[cn]=0;
	for(j=0,i=0;i<cn&&j<n;i++)
	   if(pt[i]=='\n'){ DScpt[++j]=pt+i+1; pt[i]=0; }
	   else if(pt[i]==1)pt[i]='\n';

	fclose(fp);
	}
return DScpt;
}

char *ReadFile(char *fname,unsigned int *len0)
{
unsigned int len;
char *buf;
FILE *fp=PathOpen(fname,"rt");
if(fp==NULL){KShowMsg(fname,nOpen,MB_ICONERROR);return NULL;}
else {/* open ok */
len=filelength(fileno(fp));
if(len>0xfffb ){
	KShowMsg("FileSize>=64k,\nabort to proccess %s!",fname,MB_ICONWARNING);
	fclose(fp);	return NULL;
	}
buf=(char *)malloc(len+4);
if(buf==NULL){
	popMsg("Fail to alloc memory !",fname,MB_ICONERROR);
	fclose(fp);	return NULL;
	}

len=fread(buf,1,len,fp);
fclose(fp);	buf[len]=0;	*len0=len;
return buf;
	}
}

char *jxcmd(char *combuf,char *pcmdchs,int *numbcom)
{
int i, len;
char *cmdpm=NULL, *pcmd, *buf2=(char *)malloc(480);
fmtVal(combuf);
for(i=0;combuf[i];i++)
   if(combuf[i]=='\\'||combuf[i]==' '||combuf[i]=='.'){
	cmdpm=combuf+i;	memcpy(buf2,combuf,i);
	buf2[i]=0;	fmtVal(cmdpm);
	break;
	}
if(cmdpm==NULL)strcpy(buf2,combuf);
len=fmtVal(buf2);
i=1;
pcmd=memstr(pcmdchs,0,buf2,len,&i);
if(pcmd&&(pcmd[len]==','||pcmd[len]==0)
&&pcmd[-1]>47&&pcmd[-1]<58)
{
for(i=0;pcmd[i-1]!=','&&pcmd+i!=pcmdchs;i--);
*numbcom=atoi(pcmd+i);
}
else *numbcom=0;
free(buf2);
return cmdpm;
}

void jxpm(char *pm,char **pt,int cn)
{
int i;
if(pm==NULL||*pm==0)return;
fmtVal(pm);
pt[0]=pm;	cn--;
for(i=0;i<cn;i++){
	pt[i+1]=strchr(pt[i],32);
	if(pt[i+1]){ *pt[i+1]=0; pt[i+1]++; 
		fmtVal(pt[i+1]);
		}
	else break;
	}
}

char *IsExec(char *fname,char (*pExt)[5],int cn)
{
char *buff;
int len,i;
if(access(fname,0)==0)return fname;
else {
len=strlen(fname);
buff=(char *)malloc(len+10);
strcpy(buff,fname);
for(i=0;i<cn;i++){
	strcpy(buff+len,pExt[i]);
	if(access(buff,0)==0)return buff;
	}
free(buff);
return NULL;
	}
}

#endif