/*
	Write & edit by Linjianghua(Xempo)
	Copyright Linjianghua(Xempo)
	Reserve all rights this file
*/
#include "\c_lib\c_lib.def"
#include "\exlnkc\fmem.cpp"
#include "\exlnkc\readfile.c"
#include "\exlnkc\memchrs.c"

extern xlnktxt *Creat_XLNK_File(char *memfile,char ch);
extern bool Append_XLNK_File(xlnktxt *xlnk,char *srcfile);
extern void Cnt_XLNK_File(char *fname);
int mdf;

char *catstr(char *dat,char *extdat)
{
int len=strlen(dat);
char *pRt=(char *)malloc(len+strlen(extdat)+4);
strcpy(pRt,dat);
strcpy(pRt+len,extdat);
return pRt;
}

char *MPdir;
FILE *MPDopenf(char  *fnm,char *fmode)
{
FILE *fp;
char  *pt=fnm;
start:fp=fopen(pt,fmode);
if(fp==NULL){
	if(pt==fnm&&MPdir){
		pt=catstr(MPdir,fnm);
		goto start;
		}
	else if(pt!=fnm)free(pt);
	}
return fp;
}

extern char nofile[];

void Destory(xlnktxt *xlnk)
{
  if(xlnk&&xlnk->xlnkfp){
    if(mdf){ rewind(xlnk->xlnkfp); fwrite(xlnk,8,1,xlnk->xlnkfp); }
    fclose(xlnk->xlnkfp);
    free(xlnk);
  }
}

size_t ReFixSiz(char *fbuf)
{
  size_t i;
  for(i=strlen(fbuf)-1;i>0&&(fbuf[i]==13||fbuf[i]==10);i--)fbuf[i]=0;
  fbuf[++i]=10;  fbuf[++i]=0;
  return i;
}

xlnktxt *Creat_XLNK_File(char *memfile,char ch)
{
xlnktxt *xlnk;
FILE *fp;
  if(ch=='b'||access(memfile,0)){
    fp=fopen(memfile,"wb+");
    if(fp==NULL){ printf("** Can't create: %s",memfile); return NULL; }
    xlnk=(xlnktxt *)malloc(sizeof(xlnktxt));
    xlnk->ctrlpos=8;xlnk->cnt=0;
  }
  else {
    fp=fopen(memfile,"rb+");
    xlnk=(xlnktxt *)malloc(sizeof(xlnktxt));
    fread(xlnk,8,1,fp);
  }
  xlnk->xlnkfp=fp;
  return xlnk;
}

void Cnt_XLNK_File(char *fname)
{
  xlnktxt *xlnk=xlnkOpen(fname);
  if(xlnk)printf("Total data: %ld\n",xlnk->cnt);
  else printf(nofile,fname);
}

bool Append_XLNK_File(xlnktxt *xlnk,char *srcfile)
{
  bool msg=false;
  if(srcfile){
    if(xlnk->xlnkfp){
      UINT *buff, cn[2];
      size_t len, i, j, n, b;
      char *fbuf=ReadFile(srcfile,&len);
      if(fbuf){
	if(xlnk->cnt){
	  buff=(UINT *)malloc(xlnk->cnt*4);
	  fseek(xlnk->xlnkfp,xlnk->ctrlpos,0);
	  fread(buff,xlnk->cnt*4,1,xlnk->xlnkfp);
	}
	len=ReFixSiz(fbuf);
	fseek(xlnk->xlnkfp,xlnk->ctrlpos,0);
	fwrite(fbuf,len,1,xlnk->xlnkfp);
	if(xlnk->cnt){
	  fwrite(buff,xlnk->cnt*4,1,xlnk->xlnkfp);
	  free(buff);
	  }
	for(i=0,n=0,j=0;i<len;i++)if(fbuf[i]=='\n'){
	  b=ToNextLen(fbuf+i);
	  if(b>1){
	    *cn=i-j+1;
	    cn[1]=xlnk->ctrlpos+j;
	    j=i+b;
	    fwrite(cn,4,1,xlnk->xlnkfp);
	    n++; i+=b;
	  }
	}
	xlnk->ctrlpos+=len;  xlnk->cnt+=n;
	mdf=1;		msg=true;
      }
      /*      else printf("Can't open %s\n",srcfile);*/
    }
    else puts("** ExLnkTxt buffer is null");
  }
  else puts("** filename is null");
  return msg;
}

int main(int n,char **pm)
{
  if(n>2){
    xlnktxt *xlnk=NULL;
    int i;
    if(*pm[1]=='-')switch(pm[1][1]){
      case 'b' :
      case 'c' :
	puts("Extend Link Text(data) compiler, Copyright Linjianghua(xempo)\n");
	xlnk=Creat_XLNK_File(pm[2],pm[1][1]);
	if(xlnk)for(i=3;i<n&&Append_XLNK_File(xlnk,pm[i]);i++);
	else i=n+1;
	puts(i<n? "Compilation exited abnormally !\n":"Compilation finished !\n");

	break;
      case 'r' :
	if((xlnk=xlnkOpen(pm[2]))!=NULL){
	char *pt;
	for(i=3;i<n;i++){
	  pt=xlnkRead(xlnk,atoi(pm[i]));
	  if(pt){ puts(pt); free(pt); }
	  else printf("No such data: index=%s\n",pm[i]);
	}
	}
	else printf(nofile,pm[2]);
	break;
    case 't' : Cnt_XLNK_File(pm[2]);
  }
if(xlnk)Destory(xlnk);
  }
  else puts("Usage: xlnkfc [-com] file1.xlt [srcfile1...]|[index1...]\n\tcom = c(Compile) | b(reBuild) | r(Read) | t(Total)");
  return 0;
}
