/*
	Designed & modify by Linjianghua
	reserve all code of this file
*/

#include <process.h>
#include <fcntl.h>
#include "\rtlprj\conmsg.def"
#include "\c_lib\c_lib.def"
#define malloc		malloc
#include "\c_lib\catstr.c"
#include "\c_lib\strstrcs.c"
#include "\c_lib\memstr.c"
#include "\c_lib\fmtVal.c"
#include "\c_lib\fmtinput.c"
#include "\c_lib\isremchs.c"

extern unsigned _stklen=2800;
#define _MSG_(n)	16+n
/* Setfiledata member */
static int ErrMsg,/* have no effect val flag */
	oln, nwln;
/* */

int idxdscpt;

void *memapp(size_t sz)
{
union REGS rg;
unsigned int mem[2];
rg.x.ax=FP_SEG(mem);
rg.x.bx=FP_OFF(mem);
*mem=sz;
int86(201,&rg,&rg);
return MK_FP(*mem,mem[1]);
}

int MPDopen(char *fnm, int fmode)
{
int fno;
char  *pt=fnm;
start:fno=_open(pt,fmode);
if(fno==-1){
	if(pt==fnm&&*_argv){
		pt=catstr(*_argv,fnm);
		goto start;
		}
	else if(pt!=fnm)free(pt);
	}
return fno;
}

unsigned int FmtText(char *buf,unsigned int len)
{
  unsigned int i;
  for(i=0;i<len;i++)if(buf[i]==13&&buf[i+1]==10)
    memmove(buf+i,buf+i+1,len-- - i);/* len exclude 0, so ... */
  return len;
}

char *ReadFile(char *fname,unsigned int *filelen,bool txtmsg)
{
unsigned int len;
char *buf;
int fno;
if((fno=MPDopen(fname,O_BINARY))==-1){ idxdscpt=_MSG_(7); return NULL; }
else {/* open ok */
  len=filelength(fno);
  if(len>0xfffb||(buf=memapp(len+4))==NULL){
	idxdscpt=_MSG_((len>0xfffb? 2:3));
	_close(fno);	return NULL;
	}
  len=_read(fno,buf,len);
  _close(fno);	buf[len]=0;
  *filelen=txtmsg? FmtText(buf,len):len;
  return buf;
	}
}

/*void FreeConMsg(ConMsg *conMsg,int Allclr)
{
int i;
if(conMsg->fileRec)free(conMsg->fileRec);
if(conMsg->invfile)free(conMsg->invfile);
if(conMsg->ReVar)free(conMsg->ReVar);
if(conMsg->org)free(conMsg->org);
if(conMsg->mmdat){
	for(i=0;i<conMsg->ndt;i++)free(conMsg->mmdat[i]);
	free(conMsg->mmdat);
}
if(Allclr)free(conMsg);
else memset(conMsg,0,sizeof(ConMsg));
}*/

static void DatCtrlApp(DatCtrl *ctrl,int addcn)/* realloc org,nw */
{
if(ctrl->toluse>=ctrl->tolmem){
	char **dat1,**dat2;
	int t;
	ctrl->tolmem += addcn;
	dat1=(char **)memapp(ctrl->tolmem*8);
	dat2=dat1+ctrl->tolmem;
	if(ctrl->toluse>0){
	    for(t=0;t<ctrl->toluse;t++)
		{ dat1[t]=ctrl->dat1[t]; dat2[t]=ctrl->dat2[t];	}
	    free(ctrl->dat1);
		}
	ctrl->dat1=dat1;	ctrl->dat2=dat2;
	}
}

static void AddMsg(char **dat,char *add_)
{
UINT vln,dln;
char *vp;
vln= *dat? strlen(*dat):0;
dln=vln+strlen(add_)+8; /* in fact, alloc mem at least:len+1 every time. */
vp=(char *)memapp(dln);
if(*dat){	
	strcpy(vp,*dat);
	vp[vln++]='\r';	vp[vln]='\n';
	strcpy(vp+vln+1,add_);
	free(*dat);
	}
else strcpy(vp,add_);
*dat=vp;
}

static bool IsModeSet(ConMsg *conMsg,char *txt)
{/* [ Mode set = 1 ]   0 is normal, otherwise is reset */
char *pt;
int len;
BOOL fg=FALSE;
if(*txt==0)return TRUE;  /* is the mode,so skip */

len=fmtVal(txt);
if( *txt!='[' || txt[len-1]!=']' )return FALSE; /* is not mode */

/* ValSet=0; have done */
txt[len-1]=0;	txt++;
pt=strchr(txt,'=');
if(pt){
	*pt=0;	fmtVal(txt);
	if(stricmp(txt,"Mode set")==0){
		fmtVal(++pt);
		conMsg->ValSet=atoi(pt);
		fg=TRUE;
	}
}
return fg;
}

static int VerifyDat(ConMsg *conMsg,char *pt,char CH,int msg,bool *IsRem)
/* i>=0 the dat is effect,ǿȡ(еλ);0 no effect  */
{
char *pi,**Org,**Nw;
BOOL flg1;
int t,cur,i,tn=conMsg->toluse;
DatCtrlApp((DatCtrl *)&conMsg->toluse,32);
if( CH>125 )goto skp;
if(IsRemChs(pt,IsRem,CH)||IsModeSet(conMsg,pt) )return -1;
pi=strchr(pt,'=');
if(pi==NULL)return -1;
*pi=0;	pi++;

if((oln=fmtVal(pt))==0||(nwln=fmtVal(pi))==0)return -1;
Org=conMsg->org;
Nw=conMsg->nw;
if(conMsg->ValSet){	Org[tn]=pi;	Nw[tn]=pt;	}
else { Org[tn]=pt;	Nw[tn]=pi; }

skp:	cur=tn;
flg1=1+(msg&2);
for(t=0;t<tn;t++){/* ǷѼص*/
 if(memstr(Org[cur],0,Org[t],0,flg1)){
   if(msg_memstr){
	if(stricmp(Nw[t],Nw[cur])==0)return -1; /*  2 both equ */
	if((msg&4)==0){ /* can't set mult-val ظֵ */
		AddMsg(&conMsg->ReVar,Org[cur]);
		conMsg->cnReV++;	ErrMsg=TRUE;
		return -1;
			}
	else break;
	  }
  else {/* only compare first ʵֻȽһΣһʵ */
	pi=Org[cur];	pt=Nw[cur];
	for(i=tn;i>t;i--){ Org[i]=Org[i-1];  Nw[i]=Nw[i-1];	}
	Org[t]=pi;		Nw[t]=pt;
	cur=t;/* adjust Ƚʱֵ(pos) */
	break; /* is right ?? */
	 }
  }
}/* is loaded? */
conMsg->toluse++;
return cur;
}

static char **ReAppDat(char **dat,unsigned int *m,unsigned int n)
{/* *m is dat's count  */
if(*m<=n){
char **tmp;
int a,cn;
*m += 8; cn=*m;
tmp=(char **)memapp( cn * 4 );
for(a=0; a < cn ; a++)tmp[a]=a<n? dat[a]:NULL;
if( n > 0 )free(*dat);
return tmp;
	}
else return dat;
}

static char **CalcFiles(TFD *conMsg,char *inpt,int *cn)
{/* use setagrv replace */
char *pt, **fname, *hd;
int n=10;
unsigned int fn=10, tol=0, t;
FmtInput(inpt, ";, ", 32, &n);
fname=(char **)malloc(40);
memset(fname,0,40);
hd=inpt;	pt=inpt;		/* init dats */
while(*pt){
  if(*pt==32||pt[1]==0&&fname[tol]!=pt){
	if(*pt==32)*pt=0;
	fname[tol]=hd;  hd=pt+1;
	for(t=0;t<tol;t++)if(stricmp(fname[t],fname[tol])==0)goto skp;
	if(strstr(conMsg->fileRec,fname[tol])||strstr(conMsg->invfile,fname[tol]))goto skp;
	fname=ReAppDat(fname,&fn,++tol);
	}
skp:pt++;
}
*cn=tol;
return fname;
}

unsigned int MakeConMsg(ConMsg *conMsg,char *buf,int msg)/* return data's count */
{/* buf must heap,because it would be free */
unsigned int rt=0;
if(buf){
unsigned int i, len=strlen(buf)+1, n=conMsg->toluse, datlen=0;
char chr, *pt=buf, memblk[4]={10,13,';'};
bool IsRem=false;
conMsg->ValSet=0;
/* above is init some members val of class */
for (i=0; i<len; i++){
  chr = buf[i];
  if(memchr(memblk,chr,4)){
	 buf[i]=0;
	 if(VerifyDat(conMsg,pt,chr,msg,&IsRem)>-1)datlen += oln+nwln+2;
	 if(buf[i+1]==10||buf[i+1]==13/* unix */){ pt=buf+i+2; i++; }
	 else	pt=buf+i+1;
	  }
   }

rt=conMsg->toluse-n;
if(rt){
  conMsg->mmdat=ReAppDat(conMsg->mmdat, &conMsg->mdt, conMsg->ndt);
  if(datlen+128 < len){  /*====compacted ==========*/
    char **Org=conMsg->org, **Nw=conMsg->nw;
    pt = (char *)memapp(datlen + 4);
    conMsg->mmdat[conMsg->ndt] = pt;
    while(n<conMsg->toluse){
	strcpy(pt, Org[n]);
	Org[n] = pt;
	pt += strlen(pt) + 1;
	strcpy(pt, Nw[n]);
	Nw[ n++ ] = pt;
	pt += strlen(pt) + 1;
	}
    free(buf);
   }/*====compacted ==========*/
  else conMsg->mmdat[conMsg->ndt] = buf;
conMsg->ndt++;
}
else free(buf);
/*ReCmpbk(rt);*/
}
return rt;
}

/* Use file msg
0 pop msg for show no effect loaded data.
1 CASE source
2 bit set 0, no mult-var set,
3 bit set 1, show errmsg
above is bit pos  //default is 1+0+4
*/
void CreatConMsg(ConMsg *conMsg,char *fnames,int msg)
{
char **flnm, *buf;
int j, cnOrg, cnfl;
unsigned int len;
if(fnames==NULL||fnames[0]==0){	idxdscpt=_MSG_(0); goto skpmsg; }

flnm=CalcFiles(conMsg,fnames,&cnfl);
if( (msg&1) && cnfl==0){
	free(flnm); idxdscpt=_MSG_(1);
	skpmsg:/*_errmsg(kProg->kxbp,ConCap);*/
	return;
	}
cnOrg=conMsg->cnRec;	ErrMsg=FALSE;
/*-------------processe file----------------*/

for(j=0;j<cnfl;j++)if((buf=ReadFile(flnm[j],&len,true))!=NULL){
   if(MakeConMsg(conMsg,buf,msg)>0){  /* return add cn */
	AddMsg(&conMsg->fileRec,flnm[j]);
	conMsg->cnRec++;
	}
   else AddMsg(&conMsg->invfile,flnm[j]); /* set dat=0 */
}/* open seccess */
/* ----processe file end----------- */
free(flnm);
if(conMsg->cnRec==cnOrg&&/* msg:some use no need this warn */
   (msg&1)){ idxdscpt=_MSG_(4); goto skpmsg; }

if(ErrMsg && (msg&4)==0 && (msg&8) && conMsg->ReVar){
	idxdscpt=_MSG_(5);  goto skpmsg;
	}
}

char memfunc[]="memapp";
int main(int cn,char **pms)
{
if(cn>3){
  ConMsg *_conMsg;
  unsigned int seg, off;
  char *mpms[2], *pt=strrchr(*_argv,'\\');
  if(pt)pt[1]=0;
  seg=atol(pms[2]); off=atol(pms[3]);
  _conMsg=(ConMsg *)MK_FP(seg,off);
  mpms[1]=NULL; *mpms=memfunc;
  if(spawnvp(P_WAIT,memfunc,mpms)==-1){ idxdscpt=_MSG_(8);/*"Fail to carry memapp"*/ goto ex; }
  switch(_conMsg->nCom){
  case 64 : MakeConMsg(_conMsg,pms[1],_conMsg->rtcode); break;
  case 4 :  CreatConMsg(_conMsg,pms[1],_conMsg->rtcode);
		break;
	}
ex:  _conMsg->rtcode=idxdscpt; /* lists(n,**lst) */
}
}