/*
  Designed by LinJiangHua(xempo) 2003-2006
  Copyright 2004-2006,2008-2010 Linjianghua(xempo).
  All Rights Reserve.
*/

#include <dos.h>
#include <time.h>
#include <io.h>
#include "\c_lib\c_lib.def"
#include "\storplus\storplus.def"

#define BSlen   27  /* can't change for compact */
#define Btaglen 17
char Verchs[]=" V", **plusInfo,  *ScanBuf,
dysver[]="Storage Plus kern 1.09", ExtSRL[2][5]={".srl",".xbl" },
dysTag[3][22]={
"LinJiangHua DySt V2.0",
"eXecuting Binary V000",
"StructRuntime Lib V00"};

/* I take first LAY DIRE as root like DOS have many drivers,
but use \(open,cd,list...) can be null current work DIRE */

/*
"LinJiangHua FMTs V1.0.0\r" => dy-Storage tag
"LinJiangHua FMTb V.....\r" => Biaoge tag
"LinJiangHua FMTr V....\r"  => Rtl tag
{13,26} is end tag
*/
int DysMsg; /* all kind of msg for NumbScan, include creatdir msg,
 >0x7ffe is success, other is (err)msg index */
char dysfver[dir_style_cnt][5]={ "V1.1", "V1.2", "V1.3", "V2.0" },
__ver[dir_style_cnt][4]={ {0,18,55,0},{1,24,60,0},
 {2,34,74,0},/*  */
 {3,34,74,0} };
/*dysfver[dir_style_cnt][5]={ "V1.0", "V1.3", "V1m0" },
__ver[3][3]={ {0,18,55},{1,22,72},{2,30,72} };*/

void (*TypeTips)(const char *fnam,const char *descpt, int *brw);
int (*popMsg)(const char *,const char *,int);

void *zalloc(int sz)
{
return memset( malloc(sz), 0, sz);
}

void dkwrite(Dysto *dys,void *dat,size_t datlen,long pos)
{
fseek(dys->fpt,pos,0);
fwrite(dat,datlen,1,dys->fpt);
}

un_Int dkread(Dysto *dys,void *dat,un_Int len, un_Int cnt,long pos)
{
fseek(dys->fpt,pos,0);
return fread(dat,len,cnt,dys->fpt);
}

char *_GetVer(char *chs,const char *fnd, char *tm_mode)
{
  char *pt=strstr(chs,fnd);
  *tm_mode=128;
  if(pt){ 
    char *end=strchr(pt,'\r');/* compact old ver */
    if(end){ *end=0;	*tm_mode=0;	}
    return pt+1;
  }
  return (char *)SPC;
}

void CreatSeg(Dysto *lib,DIRE *Dir)
{
size_t len=Dir->statLen*Dir->PreAlloc +4;
void *dat=zalloc(len);
dkwrite(lib,dat,len,lib->fsz);
lib->fsz+=len; lib->use+=len;
Dir->sz+=len;
free(dat);
}

long n_DatLen(DIRE *Dir1,char *stat)
{
long len=0;
int i;
DAU *pdau=(DAU *)(stat+Dir1->PosDAU);
for(i=0;i<Dir1->dau;i++)
   len+=pdau[i].mlen;  /* as mlen is unsigned int, overflow, so use long ...*/
return len;
}

void Destory(Dysto *lib, Dysto * (*cmpr)(Dysto *,const char *))
{ 
if(lib/*&&lib->fpt*/){
  if((lib->mdf&127)||(lib->cDir&&lib->adr!=lib->cDir->selfaddr)){
    lib->adr=lib->cDir->selfaddr;
    lib->date=_CurDate(lib->mdf);
    dkwrite(lib,&lib->DirAdr,lib->dysSize,BSlen);
	}
  if(lib->verNo>1){
    if(lib->cmprSiz<512)lib->cmprSiz=512;
    if(cmpr&&lib->use+lib->cmprSiz<lib->fsz)lib=cmpr(lib,NULL);
  }
  if(lib->cDir)_release(lib,lib->cDir);
  if(lib->fname)free(lib->fname);
  fclose(lib->fpt);
  free(lib); /* why not at first ?? because stack for lib possible*/
}
}

Dysto *Instance(const char *fnam,int brw)
{
int  verNo=-1, n, errNo=0;
FILE *pff;
const char *oldfnam=fnam;
char descpt[32], *pt;
Dysto *lib=DSLalloc();

ropen: pff=PathOpen(fnam,"rb+");
if(pff==NULL){
  if(verNo>0){ free(fnam); fnam=oldfnam; goto _type_;	}
catExt:	while(verNo<1)if(memstr(fnam,strlen(fnam)+1,ExtSRL[++verNo],5,0)==NULL){
		if(fnam!=oldfnam)free(fnam);
		fnam=catstr(oldfnam,ExtSRL[verNo],0);
		goto ropen;
		}
ex:	if(brw)KShowMsg(oldfnam,plusInfo[errNo],1);
	free(lib);
	if(fnam!=oldfnam)free(fnam);
	return NULL;
	}
else {
	fread(descpt,BSlen,1,pff);
	for(n=0;n<3&& (pt=memstr(descpt,Btaglen,dysTag[n],Btaglen,3))==NULL;n++);
	if(pt==NULL){
		errNo=1;
		if(verNo<1/*oldfnam4==fnam*/)goto catExt;
 		else {
			_type_:	if(TypeTips)TypeTips(fnam, descpt, &brw);
			goto ex1;
			}
		}

	*(long *)lib=descpt[24]>10/* '0' */ ? *(long *)__ver[0]:*(long *)(descpt+24);
	strcpy(lib->vers,_GetVer(descpt,Verchs,n? &lib->mdf:pt));
/*	if(n==2)lib->mdf=0; // above: n!=0 ? have process */
	if(fread(&lib->DirAdr,lib->dysSize,1,pff)<1||lib->cn<0){
	errNo=5;
	ex1:    if(pff)fclose(pff);
	goto ex;
	}
}
if(fnam!=oldfnam)free(fnam);
lib->fsz=filelength(fileno(pff));
lib->fpt=pff;
lib->fname=(char *)curprgnam;
return lib;
}

long NumbScan(Dysto *dys,DIRE *Dir,long numb,int flg)
{
long *plong, rt, seg, pos;
char *segs_buf, *pcell;
unsigned int len, i, j, flagpos, clen;
/* DAU *parm_DAU;  *pdk, *pdk1, */
if(dys==NULL/*||dys->fpt==NULL*/){ DysMsg=2; return MSG_NO_NUMB; }
if(Dir==NULL)goto _skp;
DysMsg=0x7fff;
flagpos=Dir->PosDAU-1;
/*parm_DAU=(DAU *)(ScanBuf+flagpos+1);*/
seg = flg!=DYSTO_LIST? Dir->nmbadr:Dir->nx_seg;
if(seg==0){
  switch(flg){
  case DYSTO_WRITE :
	Dir->nmbadr=dys->fsz;
	CreatSeg(dys,Dir);
	break;
  case DYSTO_LIST : return 0;
  default :_skp: DysMsg=4;	return MSG_NO_NUMB;
  }
}
clen=Dir->statLen;

switch(flg){
case DYSTO_RESCU : 
case DYSTO_WRITE : 
case DYSTO_READ : rt=flg;
	ScanBuf=zalloc(clen);
	if(seg==0&&flg==DYSTO_WRITE)return Dir->nmbadr;
	break;
default : rt=0;	
}

len=Dir->PreAlloc*clen+4;
segs_buf=(char *)malloc(len);
plong=(long *)(segs_buf+len-4);
while( seg>0 ){
if(dkread(dys,segs_buf,len,1,seg)<1){ DysMsg=5; goto ExitScan; }

/*#ifndef _K_RUNTIME_*/
if(flg==DYSTO_LIST){ Dir->nx_seg=*plong; return (long)segs_buf; }
/*#endif*/

for(i=0,j=0; i<Dir->PreAlloc; i++,j+=clen){
   pos=seg + j;
   pcell=segs_buf + j;/*   flags=pcell[flagpos];*/
   switch( pcell[flagpos] ){
   case 1 :
	if(numb==*(long *)pcell)switch(flg){
	  case DYSTO_DEL : FixStat(dys,Dir,pcell,-1,pos);
			goto _exit_;
	  case DYSTO_WRITE : rt=pos;
	  case DYSTO_READ :
		segread: memcpy(ScanBuf,pcell,clen);
		goto outloop;
	  }/* sw */
	break;
   case 0 : if(rt<0&&flg==DYSTO_WRITE)rt=pos;/* flg=0; only init */
		break;
   default : switch(flg){
	  case DYSTO_WRITE :
	    if( rt>0 ||   Dir->datelog&&
		_CurDate(dys->mdf)-*(unsigned long *)(pcell+4)<0xffff)break;/* >one day or <one day can be overwrite */
	    memcpy(ScanBuf,pcell,clen);
/*	    *(long *)ScanBuf=numb;	*/
	    rt=pos;
	    break;
#ifndef _K_RUNTIME_
	  case DYSTO_RESCU : 
		if(pos>numb){
		  rt=pos;
		  goto segread;
		}
#endif
	  }/* sw */
	}
   }
seg=*plong;
}
/* here must end, Callers process self-data */
outloop:switch(flg){
	case DYSTO_DEL:
	case DYSTO_READ:
	if(i<Dir->PreAlloc)rt=pos;
	else DysMsg=4;
	break;
	case DYSTO_WRITE :
	if( /*i>=Dir->PreAlloc &&*/ rt==DYSTO_WRITE ){
		rt=dys->fsz;
		dkwrite(dys,&rt,4,pos+clen);
		CreatSeg(dys,Dir);
		}
	}
ExitScan: if(rt==flg)free(ScanBuf);/* Fail done */
_exit_: free(segs_buf);
return rt;/* stat-pos ... */
}

void GetDAU(Dysto *lib,MAU *mau,DAU *dau)
{
if(mau){
  if( dau->len ){
  size_t cn;
  mau->buf=(char *)malloc( dau->len + 2 );
  cn=dkread(lib,mau->buf,1,dau->len,dau->adr);
  if(cn<dau->len)popMsg(plusInfo[3],NULL,WrapLine);
  mau->len=cn;
  mau->buf[cn]=0;
  }
  else mau->buf=NULL;
  }
}

void GetDAUs(Dysto *dys,DIRE *Dir,char *statbuf,MAU *pdat,int cn)
{
  int i;
  DAU *dau=(DAU *)(statbuf+Dir->PosDAU);
  if(cn>Dir->dau)cn=Dir->dau;
  for(i=0;i<cn;i++)GetDAU(dys,pdat+i,dau+i);
}

bool GetNumb(Dysto *dys,DIRE *Dir,long nmb,MAU *pdat,int cn,int qfg)
/*str1,2 use to format "%s"; return: 0 is fail,other is success */
/* pdat1.len is add lenght */
{
NumbScan(dys,Dir,nmb,DYSTO_READ);
if(DysMsg>0x7ffd){
  GetDAUs(dys,Dir,ScanBuf,pdat,cn);
  free(ScanBuf);
  return true;
  }
else if(qfg)KShowMsg((char *)nmb,plusInfo[DysMsg],1);
return false;
}

void PutDAU(Dysto *lib,DIRE *Dir,char flags, DAU *dau,MAU *mau)
{
if(mau&&mau->buf){
  unsigned int wtLen=mau->len;
  if(wtLen==0)wtLen=strlen(mau->buf);
  if(flags==1){
	Dir->sz-=dau->len; lib->use-=dau->len;
	}
  if(dau->mlen<wtLen){
	dau->adr=lib->fsz;
	lib->fsz += wtLen;
	dau->mlen=wtLen;
  }
  dau->len=wtLen;/* set current len */
  Dir->sz+=wtLen;/*!! sz is Dir data's size,not disksize, defferenct fsz */
  lib->use+=wtLen;
  dkwrite(lib,mau->buf,wtLen,dau->adr);
  }
else dau->len=0;/* need, if it's used stat, so must change dau->len */
}

void WriteStat(Dysto *dys, DIRE *Dir,char *stats, int step, long pos)
{
if(Dir->datelog){
	stats[8]=step>-1? 1:2;
	*(unsigned long *)(stats+4)=_CurDate(dys->mdf);
	}
else stats[4]=step>-1? 1:2;
dkwrite(dys,stats,Dir->statLen,pos);
dys->mdf|=1;	Dir->mdf|=1;
dys->cn+=step;	Dir->cn+=step;
}

void FixStat(Dysto *dys,DIRE *Dir1, char *stats,int step, long pos)
{
long i=n_DatLen(Dir1,stats);
Dir1->sz+=i*step;	dys->use+=i*step;
WriteStat(dys,Dir1,stats, step, pos);
}

bool SetNumb(Dysto *dys,DIRE *Dir,long nmb,MAU *pdat,int cn,int qfg)
{
long pos;
int  i;
char flags;
bool rt;
DAU *dau;
if((pos=NumbScan(dys,Dir,nmb,DYSTO_WRITE))<0){
	KShowMsg((char *)nmb,plusInfo[DysMsg],1);
	return false;
	}
flags=ScanBuf[ Dir->PosDAU-1 ];
if(flags==1 && (qfg&1) && ((i=KShowMsg((char *)nmb,plusInfo[8],_Quest_|YNEA))!='y'&&i!='a')){
	rt=false;	goto _exit_;
	}
rt=true;
dau=(DAU *)(ScanBuf+Dir->PosDAU);
if(cn>Dir->dau)cn=Dir->dau;
for(i=0;i<cn;i++)PutDAU(dys,Dir, flags, dau+i,pdat+i);
*(long *)ScanBuf=nmb;
WriteStat(dys,Dir,ScanBuf, flags!=1 ? 1:0, pos);
_exit_: free(ScanBuf);
return rt;
}
